from enum import Enum
import warnings


class MapDetailTagsItem(str, Enum):
    ACCURACY = "Accuracy"
    ALT = "Alt"
    AMBIENT = "Ambient"
    ANIME = "Anime"
    BALANCED = "Balanced"
    CHALLENGE = "Challenge"
    CLASSICAL = "Classical"
    COMEDY = "Comedy"
    DANCE = "Dance"
    DANCESTYLE = "DanceStyle"
    DRUMBASS = "DrumBass"
    DUBSTEP = "Dubstep"
    ELECTRONIC = "Electronic"
    FAMILY = "Family"
    FILM = "Film"
    FITNESS = "Fitness"
    FOLK = "Folk"
    FUNK = "Funk"
    GAME = "Game"
    HARDCORE = "Hardcore"
    HIPHOP = "HipHop"
    HOLIDAY = "Holiday"
    HOUSE = "House"
    INDIE = "Indie"
    INSTRUMENTAL = "Instrumental"
    JAZZ = "Jazz"
    JPOP = "JPop"
    JROCK = "JRock"
    KPOP = "KPop"
    METAL = "Metal"
    NIGHTCORE = "Nightcore"
    NONE = "None"
    POP = "Pop"
    PUNK = "Punk"
    RB = "RB"
    ROCK = "Rock"
    SOUL = "Soul"
    SPEED = "Speed"
    SPEEDCORE = "Speedcore"
    SWING = "Swing"
    TECH = "Tech"
    TECHNO = "Techno"
    TRANCE = "Trance"
    VOCALOID = "Vocaloid"
    UNKNOWN = "Unknown"  # Add this new value

    def __str__(self) -> str:
        return str(self.value)

    @classmethod
    def _missing_(cls, value):
        for member in cls:
            if member.value.lower() == value.lower():
                return member
        warnings.warn(f"Unknown tag value: {value}. Using 'Unknown' instead.", UserWarning)
        return cls.UNKNOWN
